//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1 =  32;
extern double Period2 =   5;
extern double Period3 =   5;

double cmi[];
double cmihuu[];
double cmihud[];
double cmihdd[];
double cmihdu[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,cmihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,cmihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,cmihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,cmihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,cmi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
      IndicatorShortName("Blau candlestick momentum index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i)-iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN,i);
         double avg = iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1);
         double ava = iEma(iEma(MathAbs(priceDiff),Period1,i,2),Period2,i,3);
            if (ava != 0)
                  cmi[i] = 100.0*avg/ava;
            else  cmi[i] = 0;                  
            cmihuu[i] = EMPTY_VALUE;
            cmihud[i] = EMPTY_VALUE;
            cmihdd[i] = EMPTY_VALUE;
            cmihdu[i] = EMPTY_VALUE;
            signal[i] = iEma(cmi[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (cmi[i] > cmi[i+1]) slope[i] =  1;
               if (cmi[i] < cmi[i+1]) slope[i] = -1;
               if (cmi[i]>0)
               if (slope[i]==1)
                     cmihuu[i] = cmi[i];
               else  cmihud[i] = cmi[i];
               if (cmi[i]<0)
               if (slope[i]==1)
                     cmihdu[i] = cmi[i];
               else  cmihdd[i] = cmi[i];
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}